package br.com.fabricante.addon.exemplos.servicos;

import br.com.sankhya.modelcore.MGEModelException;
import br.com.sankhya.modelcore.util.BaseSPBean;
import br.com.sankhya.ws.ServiceContext;
import com.google.gson.JsonObject;

import javax.ejb.SessionBean;
/*

         obrigatrio seguir o padro abaixo para criar Servios (similares  endpoints):

        A documentao  OBRIGATRIA!!!!!! Sem ela, o xdoclet no conseguir gerar suas interfaces e o servio nunca ser encontrado.

        1 - Nome da classe sempre termina com *SPBean.
        2 - @ejb.bean sempre ser o Nome da classe, mas termina somente com *SP.
        3 - jndi-name sempre ser o caminho completo para a classe, cujo nome seguir o padro acima, e sempre ser separado por "/".
        4 - type - Recomendado  stateless, caso deseje outro, consulte documentao.
        5 - transaction-type - Recomendado  "Container". Caso deseje outro, consulpe documentao.
        6 - view-type - Sempre ser "remote".
        7 - @ejb.transaction - Recomendado  "Supports". Caso deseje outro, consulte documentao.
        8 - @ejb.util - Recomendado  false. Caso deseje outro, consulte documentao.


        IMPORTANTE:  necessrio tambm editar o arquivo 'service-providers.xml'. Este arquivo est em vc/src/main/WEB-INF/resources/service-providers.xml.
        Todo servio novo deve ser declarado neste arquivo, caso contrrio, este no ser localizado em tempo de execuo.
 */


/**
 * @ejb.bean name="ExemploServicoSP"
 * jndi-name="br/com/fabricante/addon/exemplos/servicos/ExemploServicoSP"
 * type="Stateless"
 * transaction-type="Container"
 * view-type="remote"
 * @ejb.transaction type="Supports"
 * @ejb.util generate="false"
 */
public class ExemploServicoSPBean extends BaseSPBean implements SessionBean {

    /*
            A criao de um mtodo que ser chamado (equivalente  um endpoint) deve seguir o padro abaixo.

            A documentao  OBRIGATRIA!!! Sem ela, o xdoclet no conseguir gerar suas interfaces e este mtodo no ser encontrado.

            1 - @ejb.interface-method - Sempre ser "remote".
            2 - O parmetro br.com.sankhya.ws.ServiceContext  OBRIGATRIO. Esta  a assinatura padro do mtodo. Ex: public void meuMetodo(br.com.sankhya.ws.ServiceContext ctx) {...}

            Importante: O mtodo abaixo ser chamado com URL/nome_projeto/service.sbr?serviceName=ExemploServicoSP.getAlgumaInfo, onde
            nome_projeto  o valor de 'rootProject.name' que est no arquivo 'settings.gradle'.

    */

    /**
     * @throws MGEModelException
     * @ejb.interface-method tview-type="remote"
     */
    public void getAlgumaInfo(ServiceContext ctx) throws MGEModelException {
        JsonObject object = new JsonObject();
        object.addProperty("codparc", "123456");
        ctx.setJsonResponse(object);
    }
}
